:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-swi7orHigher->set_prolog_flag(double_quotes,codes);true.
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_3154,_3148/_3150,_3158):-(retract(dynamicVersion(_3154,_3148/_3150,_3172))->true;true),asserta(dynamicVersion(_3154,_3148/_3150,_3158)).
prim_assertFact('Dynamic.Dynamic'(_3266),'Prelude.()'):-retract(dynamicTime(_3276)),_3290 is _3276+1,assertz(dynamicTime(_3290)),_3266=..[_3304,_3310,_3316,_3322|_3324],_3352=..[_3304,_3290,0|_3324],assertz(user:_3352),logDynamicEvent(_3310,assertz,_3352).
prim_retractFact('Dynamic.Dynamic'(_3454),_3460):-_3454=..[_3464,_3470,_3476,_3482|_3484],_3512=..[_3464,_3500,_3506|_3484],reloadNewestDynamicVersionOf(_3464),retract(dynamicTime(_3522)),_3536 is _3522+1,assertz(dynamicTime(_3536)),call(user:_3512),isInTimeInterval(_3522,_3500,_3506),!,_3586=..[_3464,_3500,_3522|_3484],retract(user:_3512),!,logDynamicEvent(_3470,retract,_3512),assertz(user:_3586),_3460='Prelude.True'.
prim_retractFact(_3752,'Prelude.False').
prim_getDynamicKnowledge(_3788):-reloadNewestDynamicVersions,dynamicTime(_3792),term2partcall('Dynamic.isKnownAtTime'(_3792),1,_3788),(compileWithSharing(function)->makeShare(_3788,_3814);_3814=_3788).
prim_isKnownAtTime(_3892,'Dynamic.Dynamic'(_3888),'Prelude.True'):-_3888=..[_3900,_3906,_3912,_3918|_3920],_3948=..[_3900,_3936,_3942|_3920],call(user:_3948),isInTimeInterval(_3892,_3936,_3942).
isInTimeInterval(_4040,_4042,_4044):-_4040>=_4042,(_4044=0->true;_4040=<_4044).
logDynamicEvent('Dynamic.Temporary',_4136,_4138):-!.
logDynamicEvent('Dynamic.Persistent',_4194,_4196):-_4196=..[_4200,_4206,_4212|_4214],_4242=..[_4200,0,0|_4214],_4260=..[_4194,_4242],user:dynamicPredInfo(_4200/_4268,_4274),logDynamic(_4260,_4274).
logDynamic(_4364,_4366):-dir2tmplockfile(_4366,_4372),lockWithFileIfNotInTransaction(_4372),executeWithFinalize((dir2logfile(_4366,_4382),open(_4382,append,_4390),writeq(_4390,_4364),put_code(_4390,46),nl(_4390),flush_output(_4390),close(_4390),addChangePid(_4366)),unlockWithFileIfNotInTransaction(_4372)).
executeWithFinalize(_4528,_4530):-on_exception(_4538,_4528,(call(_4530),printError(_4538),!,fail)),!,call(_4530).
executeWithFinalize(_4626,_4628):-call(_4628),!,fail.
prim_startTransaction(_4690):-(insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_4752,initTransaction(_4690),(unlockAllPersistentDynamics,(retract(insideTransation)->true;true),printError(_4752),fail)),!.
initTransaction(_4834):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_4838)),_4834 is _4838+1,assertz(dynamicTime(_4834)),logAllDynamicPreds(startTransaction(_4834)).
prim_commitTransaction(_4938,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_4938)),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true).
prim_abortTransaction(_5022):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_5030),map1partialM(prim_dynamic:addChangePid(0),_5030),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_5136):-findall(_5140,isDynamicDir(_5140),_5148),sort(_5148,_5136).
isDynamicDir(_5198):-user:dynamicPredInfo(_5202,_5198),\+_5198=''.
logAllDynamicPreds(_5264):-getDynamicDirs(_5268),map1partialM(prim_dynamic:logDynamic(_5264),_5268).
initializeDynamic:-user:dynamicPredInfo(_5328/_5330,_5336),initializeDynamic(_5336,_5328/_5330),fail.
initializeDynamic.
initializeDynamic('',_5406/_5408):-!,retractAllFacts(_5406/_5408).
initializeDynamic(_5482,_5476/_5478):-existsDirectory(_5482),!,checkDynSpec(_5482,_5476/_5478),setDynamicVersion(_5482,_5476/_5478,0),!.
initializeDynamic(_5584,_5586):-existsFile(_5584),!,appendAtom('ERROR: Directory "',_5584,_5598),appendAtom(_5598,'" for dynamic entries cannot be created!',_5606),writeErr(_5606),nlErr,!,fail.
initializeDynamic(_5704,_5698/_5700):-upDirectory(_5704,_5712),(existsDirectory(_5712)->createDynamicDir(_5704,_5698/_5700),setDynamicVersion(_5704,_5698/_5700,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_5704),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_5890,_5892):-atom_codes(_5890,_5898),append(_5908,[47|_5904],_5898),\+member(47,_5904),!,atom_codes(_5892,_5908).
upDirectory(_5998,'.').
checkDynSpec(_6040,_6034/_6036):-dir2specfile(_6040,_6048),existsFile(_6048),readPrologTermFile(_6048,_6058),dynamicSpec(_6034/_6036,_6058),!.
checkDynSpec(_6140,_6142):-appendAtom('ERROR: Directory "',_6140,_6150),appendAtom(_6150,'" contains no matching dynamic entries!',_6158),writeErr(_6158),nlErr,!,fail.
replayLogFile(_6244,_6238/_6240):-dir2tmplockfile(_6244,_6252),lockWithFileIfNotInTransaction(_6252),executeWithFinalize(replayLogFileWhenAlreadyLocked(_6244,_6238/_6240),unlockWithFileIfNotInTransaction(_6252)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_6360,_6354/_6356):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_6360),writeErr('\'...'),nlErr;true),getRunTime(_6414),ensurePakcsVersion(_6360),dir2dbfile(_6360,_6424),dir2pofile(_6360,_6430),consultPrologorPOFile(_6424,_6430),dir2logfile(_6360,_6442),open(_6442,read,_6450),(atEndOfStream(_6450)->close(_6450);assert(replayStatus(unchanged)),repeat,on_exception(_6480,readAndReplay(_6450),((printError(_6480)->true;true),writeErr('ERROR during reading of '),writeErr(_6442),writeErr(' (restored state might be incomplete)'),nlErr)),close(_6450),retract(replayStatus(_6544)),writeNewDatabaseIfChanged(_6354/_6356,_6360,_6544)),updateDynFactsIfNecessary(_6360,_6354/_6356),readDynamicVersion(_6360,_6616),setDynamicVersion(_6360,_6354/_6356,_6616),writeChangePids(_6360,[]),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_6650),_6660 is _6650-_6414,writeErr(_6660),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_6842):-readPAKCSVersion(_6842,_6848),_6848=pakcsVersion(_6852,_6854),prologMajor(_6864),\+_6864=_6854,dir2pofile(_6842,_6880),(existsFile(_6880)->deleteFile(_6880);true),writePAKCSVersion(_6842),!.
ensurePakcsVersion(_6984).
isCurrentPakcsVersion(_7010):-readPAKCSVersion(_7010,_7016),compilerVersion(_7020),!,(_7016=compilerVersion(_7020)->writePAKCSVersion(_7010);_7016=pakcsVersion(_7020,_7046)).
readPAKCSVersion(_7114,_7116):-dir2pakcsversionfile(_7114,_7122),existsFile(_7122),readPrologTermFile(_7122,_7116).
writePAKCSVersion(_7190):-dir2pakcsversionfile(_7190,_7196),compilerVersion(_7200),prologMajor(_7204),writePrologTermFile(_7196,pakcsVersion(_7200,_7204)).
updateDynFactsIfNecessary(_7272,_7274):-isCurrentPakcsVersion(_7272),!.
updateDynFactsIfNecessary(_7336,_7330/_7332):-compilerVersion(_7342),(pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_7336),writeErr('\' to compiler version '),writeErr(_7342),writeErr(...),nlErr;true),updateDynFacts(_7330/_7332),writeNewDatabaseIfChanged(_7330/_7332,_7336,changed),writePAKCSVersion(_7336).
updateDynFactsIfNecessary(_7508,_7510).
updateDynFacts(_7544/_7546):-functor(_7554,_7544,_7546),functor(_7562,_7544,_7546),retract(user:_7554),arg(1,_7554,_7584),arg(1,_7562,_7584),arg(2,_7554,_7600),arg(2,_7562,_7600),translateDynFactArgs(3,_7546,_7554,_7562),asserta(user:_7562),fail.
updateDynFacts(_7720).
translateDynFactArgs(_7746,_7748,_7750,_7752):-_7746>_7748,!.
translateDynFactArgs(_7826,_7828,_7830,_7832):-arg(_7826,_7830,_7840),translateDynFactArg(_7840,_7846),arg(_7826,_7832,_7846),_7864 is _7826+1,translateDynFactArgs(_7864,_7828,_7830,_7832).
translateDynFactArg(_7962,_7962):-var(_7962),!.
translateDynFactArg(_8020,_8020):-number(_8020),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_8558,_8560):-atomic(_8558),atom_codes(_8558,[40|_8570]),!,appendAtom('Prelude.',_8558,_8560).
translateDynFactArg(_8648,_8650):-atom(_8648),atom_codes(_8648,[39|_8660]),!,(_8660=[_8670]->char_int(_8650,_8670);_8660=[78,85,76]->char_int(_8650,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_8812,_8812):-atomic(_8812),!.
translateDynFactArg(_8870,_8872):-functor(_8870,_8878,_8880),translateDynFactArg(_8878,_8886),functor(_8872,_8886,_8880),translateDynFactArgs(1,_8880,_8870,_8872).
writeNewDatabaseIfChanged(_8968/_8970,_8976,changed):-!,dir2dbfile(_8976,_8984),dir2pofile(_8976,_8990),dir2logfile(_8976,_8996),appendAtom(_8984,'.bak',_9004),tell(_9004),writeq((:-dynamic _8968/_8970)),put_code(46),nl,listing(user:_8968/_8970),told,try_save_predicates(_8968/_8970,_8990),renameFile(_9004,_8984),appendAtom(_8996,'.bak',_9072),renameFile(_8996,_9072),appendAtom('touch ',_8996,_9086),shellCmd(_9086),readDynamicVersion(_8976,_9096),_9106 is _9096+1,writeDynamicVersion(_8976,_9106),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_9316/_9318,_9324,_9326):-dir2logfile(_9324,_9332),appendAtom(_9332,'.bak',_9340),renameFile(_9332,_9340),appendAtom('touch ',_9332,_9354),shellCmd(_9354).
readAndReplay(_9436):-atEndOfStream(_9436),!.
readAndReplay(_9484):-read(_9484,_9490),replayEvent(_9484,_9490).
replayEvent(_9540,end_of_file):-!.
replayEvent(_9592,startTransaction(_9588)):-readAndReplayTransaction(_9592,_9588,[]),!,fail.
replayEvent(_9660,_9662):-retract(replayStatus(_9666)),assert(replayStatus(changed)),call(user:_9662),!,fail.
readAndReplayTransaction(_9758,_9760,_9762):-atEndOfStream(_9758),!,(pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_9760),nlErr;true).
readAndReplayTransaction(_9870,_9872,_9874):-read(_9870,_9880),(_9880=commitTransaction(_9872)->callRevList(_9874);_9880=abortTransaction->true;readAndReplayTransaction(_9870,_9872,[_9880|_9874])),!.
callRevList([]).
callRevList([_10030|_10032]):-callRevList(_10032),retract(replayStatus(_10044)),assert(replayStatus(changed)),call(user:_10030).
startTransaction(_10122).
commitTransaction(_10148).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_10186),map1M(prim_dynamic:lockDynamicDir,_10186).
lockDynamicDir(_10232):-dir2lockfile(_10232,_10238),lockWithFile(_10238).
lockWithFileIfNotInTransaction(_10286):-insideTransaction->true;lockWithFile(_10286).
lockWithFile(_10340):-appendAtom('lockfile-create --lock-name ',_10340,_10348),(existsFile(_10340),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_10340),writeErr('\'...'),nlErr;true),shellCmd(_10348),!.
unlockAllPersistentDynamics:-getDynamicDirs(_10466),map1M(prim_dynamic:unlockDynamicDir,_10466).
unlockDynamicDir(_10512):-dir2lockfile(_10512,_10518),unlockWithFile(_10518).
unlockWithFileIfNotInTransaction(_10566):-insideTransaction->true;unlockWithFile(_10566).
unlockWithFile(_10620):-existsFile(_10620),!,appendAtom('lockfile-remove --lock-name ',_10620,_10632),shellCmd(_10632).
unlockWithFile(_10692).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_10718/_10720,_10726),dynamicVersion(_10726,_10718/_10720,_10746),reloadNewestDynamicVersion(_10726,_10718/_10720,_10746),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_10818):-dynamicVersion(_10828,_10818/_10824,_10832),!,reloadNewestDynamicVersion(_10828,_10818/_10824,_10832).
reloadNewestDynamicVersionOf(_10896).
reloadNewestDynamicVersion(_10928,_10922/_10924,0):-!,retractAllFacts(_10922/_10924),replayLogFile(_10928,_10922/_10924),!.
reloadNewestDynamicVersion(_11032,_11026/_11028,_11036):-readDynamicVersion(_11032,_11042),\+_11036=_11042,!,retractAllFacts(_11026/_11028),replayLogFile(_11032,_11026/_11028),!.
reloadNewestDynamicVersion(_11158,_11160,_11162):-readChangePids(_11158,_11168),currentPID(_11172),(_11168=[];_11168=[_11172]),!.
reloadNewestDynamicVersion(_11274,_11268/_11270,_11278):-retractAllFacts(_11268/_11270),replayLogFile(_11274,_11268/_11270).
createDynamicDir(_11366,_11360/_11362):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_11366),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_11366,_11424),shellCmd(_11424),dir2logfile(_11366,_11434),appendAtom('touch ',_11434,_11442),shellCmd(_11442),dir2dbfile(_11366,_11452),appendAtom('touch ',_11452,_11460),shellCmd(_11460),dir2specfile(_11366,_11470),dynamicSpec(_11360/_11362,_11482),writePrologTermFile(_11470,_11482),writePAKCSVersion(_11366).
readPrologTermFile(_11610,_11612):-open(_11610,read,_11620),read(_11620,_11612),close(_11620).
writePrologTermFile(_11688,_11690):-open(_11688,write,_11698),writeq(_11698,_11690),put_code(_11698,46),nl(_11698),flush_output(_11698),close(_11698).
readDynamicVersion(_11798,_11800):-dir2versionfile(_11798,_11806),existsFile(_11806),!,on_exception(_11826,readPrologTermFile(_11806,_11800),_11800=0).
readDynamicVersion(_11894,1).
writeDynamicVersion(_11930,_11932):-dir2versionfile(_11930,_11938),writePrologTermFile(_11938,_11932).
readChangePids(_11996,_11998):-dir2changepidsfile(_11996,_12004),existsFile(_12004),!,on_exception(_12030,readPrologTermFile(_12004,_11998),_11998=[0]).
readChangePids(_12098,[]).
writeChangePids(_12134,_12136):-dir2changepidsfile(_12134,_12142),writePrologTermFile(_12142,_12136).
addChangePid(_12200):-currentPID(_12204),addChangePid(_12204,_12200).
addChangePid(_12254,_12256):-readChangePids(_12256,_12262),(member(_12254,_12262)->true;writeChangePids(_12256,[_12254|_12262])),!.
dynamicSpec(_12350/_12352,dynamicPredicate(_12350,_12352)).
retractDeadDynamicFacts(_12398/_12400):-length(_12408,_12400),_12420=..[_12398|_12408],_12408=[_12426,_12432|_12434],dynamicTime(_12444),call(user:_12420),_12432>0,_12444>_12432,retract(user:_12420),fail.
retractDeadDynamicFacts(_12562).
dir2logfile(_12588,_12590):-appendAtom(_12588,'/eventlog',_12590).
dir2lockfile(_12644,_12646):-appendAtom(_12644,'/LOCK',_12646).
dir2tmplockfile(_12700,_12702):-appendAtom(_12700,'/LOCK',_12702).
dir2dbfile(_12756,_12758):-appendAtom(_12756,'/database.pl',_12758).
dir2pofile(_12812,_12814):-appendAtom(_12812,'/dbpred.po',_12814).
dir2specfile(_12868,_12870):-appendAtom(_12868,'/spec',_12870).
dir2pakcsversionfile(_12924,_12926):-appendAtom(_12924,'/pakcsversion',_12926).
dir2versionfile(_12980,_12982):-appendAtom(_12980,'/version',_12982).
dir2changepidsfile(_13036,_13038):-appendAtom(_13036,'/changepids',_13038).
