:-module(prim_ports,[prim_openPort/3,prim_basicServerLoop/4,prim_sendPort/5,prim_after/4,prim_openProcessPort/2,prim_ping/3,prim_timeoutOnStream/5,prim_openPortOnSocket/3,prim_connectPortAtSocket/4,prim_choiceSPEP/5,checkIncomingPortStreams/3,ifTracePort/1,readPortMessage/4,parse_received_message/4]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(prim_standard)->true;ensure_loaded(user:prim_standard).
:-current_module(prim_readshowterm)->true;use_module(prim_readshowterm).
:-dynamic only_localhost/1,tracePorts/1,mySocket/1,incomingPortStreams/2.
only_localhost(_3126):-(getEnv('PAKCS_LOCALHOST',_3132)->true;_3132=no),(_3132=yes->asserta(only_localhost(yes)),_3126=yes;asserta(only_localhost(no)),_3126=no),retract((only_localhost(_3212):-_3216,_3218)),!.
tracePorts(unknown).
ifTracePort(_3310):-tracePorts(_3314),(_3314=unknown->retract(tracePorts(_3324)),(getEnv('PAKCS_TRACEPORTS',_3334)->true;_3334=no),(_3334=yes->asserta(tracePorts(yes)),_3310;asserta(tracePorts(no)));_3314=yes->_3310;true).
prim_openPort(_3478,_3480,_3482):-nonvar(_3478),!,writeErr('ERROR: openPort: port is not a free variable'),nlErr,fail.
prim_openPort(_3568,_3570,_3572):-nonvar(_3570),!,writeErr('ERROR: openPort: stream is not a free variable'),nlErr,fail.
prim_openPort('Ports.internalPort'([],0,0,_3664),_3664,'Prelude.True').
prim_openPortOnSocket(_3714,_3716,_3718):-(retract(mySocket('Ports.internalPort'(_3722,_3724,_3726,_3728)))->_3746 is _3726+1,asserta(mySocket('Ports.internalPort'(_3722,_3724,_3746,_3728))),(_3714=_3724,_3716=_3746->true;writeErr('ERROR: inconsistent socket/port numbers in openPortOnSocket!'),nlErr);trySetSocketNumber(_3714),on_exception(_3852,listenOnNewSocket(_3714,_3834,_3728),(write('ERROR: openPortOnSocket "'),write(_3714),write('":'),nl,printError(_3852),!,fail)),atom2String(_3834,_3722),(var(_3716)->_3716=0;true),asserta(mySocket('Ports.internalPort'(_3722,_3714,_3716,_3728)))),mySocket(_3976),_3976='Ports.internalPort'(_3980,_3982,_3984,_3986),ifTracePort((writeErr('TRACEPORTS: Listen on port '),writeErr(_3984),writeErr(' at socket '),writeErr(_3982),writeErr(' on host '),(only_localhost(yes)->writeErr(localhost);string2Atom(_3980,_4032),writeErr(_4032)),writeErr(...),nlErr)),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_3976),_3718);_3718='Ports.basicServerLoop'(_3976)).
trySetSocketNumber(_4212):-var(_4212),getEnv('PAKCS_SOCKET',_4222),atom_codes(_4222,_4228),number_codes(_4212,_4228),!.
trySetSocketNumber(_4296).
prim_basicServerLoop(_4600,_4602,_4604,_4606):-freeze(_4604,blocked_prim_basicServerLoop(_4600,_4602,_4604,_4606)).
blocked_prim_basicServerLoop(_4668,_4670,_4672,_4674):-readPort(_4668,_4680,-1),_4670=[_4680|_4688],(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4668),_4688);_4688='Ports.basicServerLoop'(_4668)),_4672=_4674.
prim_timeoutOnStream(_5096,_5098,_5100,_5102,_5104):-freeze(_5102,blocked_prim_timeoutOnStream(_5096,_5098,_5100,_5102,_5104)).
blocked_prim_timeoutOnStream(_5174,_5176,_5178,_5180,_5182):-user:derefRoot(_5174,_5188),prim_timeoutOnStream_exec(_5188,_5176,_5178,_5180,_5182).
prim_timeoutOnStream_exec(_5282,_5284,'Prelude.Nothing',_5288,_5290):-var(_5284),!,_5288=_5290.
prim_timeoutOnStream_exec(_5386,share(_5382),_5390,_5392,_5394):-!,get_mutable(_5398,_5382),(_5398='$eval'(_5404)->_5390=_5404,_5392=_5394;prim_timeoutOnStream_exec(_5386,_5398,_5442,_5392,_5394),(_5442='Prelude.Nothing'->_5390=_5442;(compileWithSharing(variable)->user:propagateShare(_5442,_5390);_5442=_5390),update_mutable('$eval'(_5390),_5382))).
prim_timeoutOnStream_exec(_5618,[],'Prelude.Just'([]),_5624,_5626):-!,_5624=_5626.
prim_timeoutOnStream_exec(_5724,[_5708|_5710],'Prelude.Just'([_5708|_5710]),_5730,_5732):-!,_5730=_5732.
prim_timeoutOnStream_exec(_5818,'Ports.basicServerLoop'(_5814),_5822,_5824,_5826):-(readPort(_5814,_5832,_5818)->(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_5814),_5848);_5848='Ports.basicServerLoop'(_5814)),_5822='Prelude.Just'([_5832|_5848]);_5822='Prelude.Nothing'),_5824=_5826.
send_extvar_binding(_6264,_6266,_6268,_6270):-freeze(_6266,blocked_send_extvar_binding(_6264,_6266,_6268,_6270)).
blocked_send_extvar_binding(_6332,_6334,_6336,_6338):-evalToken(_6342),user:normalizeAndCheck(_6334,_6348,_6342,_6352),user:waitUntilGround(_6348,_6352,_6366),eval_send_extvar_binding(_6332,_6348,_6336,_6366,_6338).
eval_send_extvar_binding(_6768,_6770,_6772,_6774,_6776):-freeze(_6774,blocked_eval_send_extvar_binding(_6768,_6770,_6772,_6774,_6776)).
blocked_eval_send_extvar_binding(nostream,_6848,_6850,_6852,_6854):-writeErr('ERROR: cannot send binding for variable '),writeErr(_6850),writeErr(': '),writeErr(_6848),nlErr,!.
blocked_eval_send_extvar_binding(_6970,_6972,_6974,_6976,_6978):-show4sending(_6972,_6984,_6986),ifTracePort((writeErr('TRACEPORTS: send binding for variable '),writeErr(_6974),writeErr(': '),writeChars(user_error,_6984),nlErr)),number_codes(_6974,_7038),putChars(_6970,[86|_7038]),put_code(_6970,10),writeChars(_6970,_6984),put_code(_6970,10),flush_output(_6970),!,_6978=done.
readPort('Ports.internalPort'(_7202,_7204,_7206,_7208),_7214,_7216):-var(_7208),!,string2Atom(_7202,_7226),writeErr('ERROR: readPort: Port '),writeErr(_7204),writeErr(/),writeErr(_7206),writeErr(@),writeErr(_7226),writeErr(' only opened for writing!'),nlErr.
readPort('Ports.internalPort'(_7368,_7370,_7372,_7374),_7380,_7382):-on_exception(_7396,readFromSocket(_7372,_7374,_7380,_7382),(printError(_7396)->_7380=[];_7380=[])),!.
checkIncomingPortStreams(_7488,_7490,_7492):-retract(incomingPortStreams(_7488,[message(_7490,_7492)|_7504])),asserta(incomingPortStreams(_7488,_7504)),!.
checkIncomingPortStreams(_7590,_7592,_7594):-retract(incomingPortStreams(_7590,[ping(_7598,_7600)|_7606])),asserta(incomingPortStreams(_7590,_7606)),answerPingOnStream(_7598,_7600),checkIncomingPortStreams(_7590,_7592,_7594),!.
answerPingOnStream(_7718,_7720):-write(_7720,ok),put_code(_7720,10),flush_output(_7720),closeSocketStream(_7718,_7720),ifTracePort((writeErr('TRACEPORTS: Ping request answered.'),nlErr)).
readFromSocket(_7826,_7828,_7830,_7832):-checkIncomingPortStreams(_7826,_7838,_7840),!,readStreamLine(_7838,_7846),(parse_received_message(_7838,_7840,_7846,_7830)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_7846),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_7846),nlErr,readFromSocket(_7826,_7828,_7830,_7832)),!.
readFromSocket(_8018,_8020,_8022,_8024):-waitForSocketClientStream(_8020,_8024,_8032,_8034,_8036),ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_8032),nlErr)),(readPortMessage(_8018,_8034,_8036,_8070)->(parse_received_message(_8034,_8036,_8070,_8022)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_8070),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_8070),nlErr,readFromSocket(_8018,_8020,_8022,_8024));readFromSocket(_8018,_8020,_8022,_8024)),!.
readFromSocket(_8258,_8260,_8262,_8264):-ifTracePort((writeErr('TRACEPORTS: Timeout!'),nlErr)),fail.
readPortMessage(_8346,_8348,_8350,_8352):-readStreamLine(_8348,_8358),_8358=[_8362|_8364],checkMessageHeader(_8362,_8348,_8350,_8380),number_codes(_8384,_8364),!,(_8384=_8346->readPortMessageBody(_8380,_8352);(retract(incomingPortStreams(_8384,_8410))->append(_8410,[_8380],_8428);_8428=[_8380]),asserta(incomingPortStreams(_8384,_8428)),!,fail).
checkMessageHeader(78,_8578,_8580,message(_8578,_8580)):-!.
checkMessageHeader(80,_8652,_8654,ping(_8652,_8654)):-!.
checkMessageHeader(_8726,_8728,_8730,_8732):-writeErr('ERROR: Illegal message header received.'),nlErr,!,fail.
readPortMessageBody(message(_8816,_8818),_8824):-readStreamLine(_8816,_8824).
readPortMessageBody(ping(_8876,_8878),_8884):-answerPingOnStream(_8876,_8878),!,fail.
prim_sendPort(_9186,_9188,_9190,_9192,_9194):-freeze(_9192,blocked_prim_sendPort(_9186,_9188,_9190,_9192,_9194)).
blocked_prim_sendPort(_9264,_9266,_9268,_9270,_9272):-user:derefAll(_9264,_9278),user:derefRoot(_9266,_9290),prim_sendPortExec(_9278,_9290,_9268,_9270,_9272).
prim_sendPortExec(_9400,'Ports.internalPort'(_9390,0,_9394,_9396),'Prelude.True',_9406,_9408):-!,add2Stream(_9396,_9400),_9406=_9408.
prim_sendPortExec('Ports.SP_Put'(_9502),'Ports.internalPort'(_9506,-1,_9510,_9512),'Prelude.True',_9522,_9524):-!,user:waitUntilGround(_9502,_9522,_9524),writeChars(_9512,_9502),nl(_9512),flush_output(_9512),ifTracePort((writeErr('TRACEPORTS: SP_Put: '),writeChars(user_error,_9502),nlErr)).
prim_sendPortExec('Ports.SP_GetLine'(_9678),'Ports.internalPort'(_9682,-1,_9686,_9688),'Prelude.True',_9698,_9700):-!,readStreamLine(_9682,_9706),map2M(basics:char_int,_9718,_9706),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_9718),nlErr)),user:constrEq(_9718,_9678,_9754,_9698,_9700).
prim_sendPortExec('Ports.SP_GetChar'(_9858),'Ports.internalPort'(_9862,-1,_9866,_9868),'Prelude.True',_9878,_9880):-!,get_code(_9862,_9886),char_int(_9886,_9892),ifTracePort((writeErr('TRACEPORTS: SP_GetChar: '),writeErr(_9892),nlErr)),user:constrEq(_9892,_9858,_9924,_9878,_9880).
prim_sendPortExec('Ports.SP_EOF'(_10028),'Ports.internalPort'(_10032,-1,_10036,_10038),'Prelude.True',_10048,_10050):-!,(atEndOfStream(_10032)->_10058='Prelude.True';_10058='Prelude.False'),ifTracePort((writeErr('TRACEPORTS: SP_EOF: '),writeErr(_10058),nlErr)),user:constrEq(_10028,_10058,_10110,_10048,_10050).
prim_sendPortExec('Ports.SP_Close','Ports.internalPort'(_10208,-1,_10212,_10214),'Prelude.True',_10224,_10226):-!,close(_10214),close(_10208),_10224=_10226.
prim_sendPortExec(_10338,'Ports.internalPort'(_10328,-1,_10332,_10334),'Prelude.True',_10344,_10346):-!,writeErr('ERROR: wrong message received by stream port: '),writeErr(_10338),nlErr,_10344=_10346.
prim_sendPortExec(_10464,'Ports.internalPort'(_10454,_10456,_10458,_10460),'Prelude.True',_10470,_10472):-string2Atom(_10454,_10478),on_exception(_10512,send2Socket(_10478,_10456,_10458,_10464),(write('ERROR: send to port '),write(_10458),write(@),write(_10478),write(:),nl,(printError(_10512)->true;true))),_10470=_10472.
add2Stream(_10656,_10658):-var(_10656),!,_10656=[_10658|_10668].
add2Stream([],_10734):-write('ERROR: send: stream has not a free variable at the end'),nl.
add2Stream([_10790|_10792],_10798):-add2Stream(_10792,_10798).
prim_ping(_10864,'Ports.internalPort'(_10850,0,_10854,_10856),'Prelude.Just'(0)):-!.
prim_ping(_10936,'Ports.internalPort'(_10922,-1,_10926,_10928),'Prelude.Just'(0)):-!.
prim_ping(_11004,'Ports.internalPort'(_10994,_10996,_10998,_11000),_11008):-string2Atom(_10994,_11014),on_exception(_11036,ping2SocketPort(_11014,_10996,_10998,_11004,_11008),_11008='Prelude.Nothing').
ping2SocketPort(_11100,_11102,_11104,_11106,_11108):-connect2socket(_11100,_11102,_11116,_11118),number_codes(_11104,_11124),putChars(_11118,[80|_11124]),put_code(_11118,10),flush_output(_11118),getElapsedTime(_11150),ifTracePort((writeErr('TRACEPORTS: Ping to "'),writeErr(_11102),writeErr(/),writeErr(_11104),writeErr(@),writeErr(_11100),writeErr('"'),nlErr)),waitForInputDataOnStreams([_11116],_11106,_11238),(_11238=0->readStreamLine(_11116,_11250),closeSocketStream(_11116,_11118),getElapsedTime(_11260),_11270 is _11260-_11150,ifTracePort((writeErr('TRACEPORTS: Ping answer received in '),writeErr(_11270),writeErr(' ms'),nlErr)),_11108='Prelude.Just'(_11270);ifTracePort((writeErr('TRACEPORTS: No ping answer received'),nlErr)),_11108='Prelude.Nothing').
prim_connectPortAtSocket(_11512,_11514,_11516,'Ports.internalPort'(_11502,_11504,_11506,'Prelude.()')):-user:derefRoot(_11512,_11504),user:derefRoot(_11514,_11506),user:derefAll(_11516,_11502),!.
send2Socket(_11634,_11636,_11638,_11640):-connect2socket(_11634,_11636,_11648,_11650),number_codes(_11638,_11656),putChars(_11650,[78|_11656]),put_code(_11650,10),show4sending(_11640,_11680,_11682),writeChars(_11650,_11680),put_code(_11650,10),flush_output(_11650),ifTracePort((writeErr('TRACEPORTS: Sent to "'),writeErr(_11636),writeErr(/),writeErr(_11638),writeErr(@),writeErr(_11634),writeErr('": '),writeChars(user_error,_11680),nlErr)),rev(_11682,_11790),receive_extvar_bindings(_11648,_11790).
receive_extvar_bindings(_11918,[]):-!,ifTracePort((writeErr('TRACEPORTS: Closing send-connection'),nlErr)),close(_11918).
receive_extvar_bindings(_11996,_11998):-readStreamLine(_11996,_12004),_12004=[86|_12010],number_codes(_12020,_12010),readStreamLine(_11996,_12028),(deleteIndexVariable(_12020,_11998,_12036,_12038)->true;writeErr('ERROR: Illegal binding for logical variable received:'),nlErr,_12038=_11998),(parse_received_message(nostream,nostream,_12028,_12082)->ifTracePort((writeErr('TRACEPORTS: Received binding for variable '),writeErr(_12020),writeErr(': '),putChars(user_error,_12028),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_12028),nlErr),!,_12036=_12082,receive_extvar_bindings(_11996,_12038).
show4sending(_12268,_12270,_12272):-numberVars(_12268,_12278,[],_12272),show_term(_12278,qualified,_12270,[]).
getVariableIndex(_12364,[(_12352,_12354)|_12360],_12354):-_12364==_12352,!.
getVariableIndex(_12440,[_12434|_12436],_12444):-getVariableIndex(_12440,_12436,_12444).
getIndexVariable(_12508,[(_12506,_12508)|_12514],_12506):-!.
getIndexVariable(_12582,[_12576|_12578],_12586):-getIndexVariable(_12582,_12578,_12586).
deleteIndexVariable(_12650,[(_12648,_12650)|_12656],_12648,_12656):-!.
deleteIndexVariable(_12740,[_12728|_12730],_12744,[_12728|_12736]):-deleteIndexVariable(_12740,_12730,_12744,_12736).
parse_received_message(_12818,_12820,_12822,_12824):-readTerm(_12822,qualified,_12832,_12834),skipWhiteSpace(_12832,[]),extractVars(_12834,_12824,[],_12850),send_extvar_bindings(_12850,_12856,_12820),closeStreamAfterDones(_12856,_12818,_12820).
send_extvar_bindings([],[],_12956).
send_extvar_bindings([(_12998,_13000)|_13006],[_13010|_13012],_13020):-send_extvar_binding(_13020,_12998,_13000,_13010),send_extvar_bindings(_13006,_13012,_13020).
closeStreamAfterDones([],nostream,_13102):-!.
closeStreamAfterDones([],_13158,_13160):-ifTracePort((writeErr('TRACEPORTS: Closing receive-connection'),nlErr)),closeSocketStream(_13158,_13160).
closeStreamAfterDones([_13240|_13242],_13248,_13250):-closeStreamAfterDones(_13240,_13242,_13248,_13250).
closeStreamAfterDones(_13598,_13600,_13602,_13604):-freeze(_13598,blocked_closeStreamAfterDones(_13598,_13600,_13602,_13604)).
blocked_closeStreamAfterDones(_13666,_13668,_13670,_13672):-closeStreamAfterDones(_13668,_13670,_13672).
prim_openProcessPort(_13752,'Ports.internalPort'(_13742,-1,0,_13748)):-user:derefAll(_13752,_13760),string2Atom(_13760,_13772),execCommand(_13772,_13748,_13742,_13782).
prim_choiceSPEP(_14132,_14134,_14136,_14138,_14140):-freeze(_14134,freeze(_14138,blocked_prim_choiceSPEP(_14132,_14134,_14136,_14138,_14140))).
blocked_prim_choiceSPEP(_14216,_14218,_14220,_14222,_14224):-user:derefRoot(_14216,_14230),prim_choiceSPEP_exec(_14230,_14218,_14220,_14222,_14224).
prim_choiceSPEP_exec(_14328,share(_14324),_14332,_14334,_14336):-!,get_mutable(_14340,_14324),(_14340='$eval'(_14346)->_14334=_14336,_14332='Prelude.Right'(_14346);prim_choiceSPEP_exec(_14328,_14340,_14388,_14334,_14336),(_14388='Prelude.Left'(_14396)->_14332=_14388;_14388='Prelude.Right'(_14418),(compileWithSharing(variable)->user:propagateShare(_14418,_14434);_14418=_14434),_14332='Prelude.Right'(_14434),update_mutable('$eval'(_14434),_14324))).
prim_choiceSPEP_exec(_14612,[_14596|_14598],'Prelude.Right'([_14596|_14598]),_14618,_14620):-!,_14618=_14620.
prim_choiceSPEP_exec('Ports.internalPort'(_14702,-1,_14706,_14708),[],_14716,_14718,_14720):-readStreamLine(_14702,_14726),map2M(basics:char_int,_14738,_14726),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_14738),nlErr)),_14716='Prelude.Left'(_14738),_14718=_14720,!.
prim_choiceSPEP_exec(_14886,'Ports.basicServerLoop'(_14882),_14890,_14892,_14894):-_14882='Ports.internalPort'(_14898,_14900,_14902,_14904),checkIncomingPortStreams(_14902,_14916,_14918),!,readStreamLine(_14916,_14924),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_14882),_14938);_14938='Ports.basicServerLoop'(_14882)),(parse_received_message(_14916,_14918,_14924,_14970)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_14970),nlErr)),_14890='Prelude.Right'([_14970|_14938]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_14924),nlErr,prim_choiceSPEP_exec(_14886,_14938,_14890,_14892,_14894)),_14892=_14894,!.
prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_96,_98),'Ports.basicServerLoop'(_102),_110,_112,_114):-_102='Ports.internalPort'(_118,_120,_122,_124),waitForSocketOrInputStreams(_124,_142,_144,_146,[_92],_150),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_102),_164);_164='Ports.basicServerLoop'(_102)),(_142=no->readStreamLine(_92,_198),map2M(basics:char_int,_210,_198),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_210),nlErr)),_110='Prelude.Left'(_210);ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_142),nlErr)),(readPortMessage(_122,_144,_146,_306)->(parse_received_message(_144,_146,_306,_316)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_316),nlErr)),_110='Prelude.Right'([_316|_164]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_306),nlErr,prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_386,_98),_164,_110,_112,_114));prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_438,_98),_164,_110,_112,_114))),_112=_114,!.
numberVars(_580,'VAR'(_576),_584,_586):-var(_580),!,(getVariableIndex(_580,_584,_576)->_586=_584;length(_584,_576),_586=[(_580,_576)|_584]).
numberVars(_720,_722,_724,_726):-isShowableArg(_720),_720=..[_734|_736],numberVarsList(_736,_748,_724,_726),_722=..[_734|_748].
numberVarsList([],[],_848,_848).
numberVarsList([_900|_902],[_906|_908],_916,_918):-numberVars(_900,_906,_916,_928),numberVarsList(_902,_908,_928,_918).
extractVars(_1006,_1006,_1010,_1010):-var(_1006),!.
extractVars('VAR'(_1084),_1090,_1092,_1094):-!,(getIndexVariable(_1084,_1092,_1090)->_1094=_1092;_1094=[(_1090,_1084)|_1092]).
extractVars(_1206,_1208,_1210,_1212):-_1206=..[_1216|_1218],extractVarsList(_1218,_1230,_1210,_1212),_1208=..[_1216|_1230].
extractVarsList([],[],_1324,_1324).
extractVarsList([_1376|_1378],[_1382|_1384],_1392,_1394):-extractVars(_1376,_1382,_1392,_1404),extractVarsList(_1378,_1384,_1404,_1394).
prim_after(_1700,_1702,_1704,_1706):-freeze(_1704,blocked_prim_after(_1700,_1702,_1704,_1706)).
blocked_prim_after(_1768,_1770,_1772,_1772):-raise_exception('Ports.after not implemented!').
